/*---------------------------------------------------------------------------
  This code is part of the book
  LOGIC PROGRAMMING TECHNIQUES: THE PROLOG LANGUAGE
  Ilias Sakellariou, Nikos Bassiliades, Petros Kefalas, Demosthenes Stamatis
  Hellenic Academic On-line Publications, 2015
----------------------------------------------------------------------------*/


%%%% Binary Number Operations 

zero_or_one(0).
zero_or_one(1).

%% is_binary/1
binary_number([X]):-
	zero_or_one(X).
binary_number([X|Rest]):-
	zero_or_one(X),
	binary_number(Rest).


bit_and(0,0,0).
bit_and(0,1,0).
bit_and(1,0,0).
bit_and(1,1,1).


bitwise_and([Bit1],[Bit2],[BitR]):-
	bit_and(Bit1,Bit2,BitR).

bitwise_and([Bit1|RestBits1],[Bit2|RestBits2],[BitR|Result]):-
	bit_and(Bit1,Bit2,BitR),
	bitwise_and(RestBits1,RestBits2,Result).

bit_or(0,0,0).
bit_or(0,1,1).
bit_or(1,0,1).
bit_or(1,1,1).

bitwise_or([Bit1],[Bit2],[BitR]):-
	bit_or(Bit1,Bit2,BitR).

bitwise_or([Bit1|RestBits1],[Bit2|RestBits2],[BitR|Result]):-
	bit_or(Bit1,Bit2,BitR),
	bitwise_or(RestBits1,RestBits2,Result).



shift_left(N,Binary,Result):-
	append(Prefix,Postfix,Binary),
	length(Prefix,N),
	length(NewPostfix,N),
	list_of(0,NewPostfix),
	append(Postfix,NewPostfix,Result).

list_of(_,[]).
list_of(El,[El|Rest]):-
	list_of(El,Rest).

even_parity([0]).
even_parity([0|Rest]):-
	even_parity(Rest).
even_parity([1|Rest]):-
	odd_parity(Rest).

odd_parity([1]).
odd_parity([1|Rest]):-
	even_parity(Rest).
odd_parity([0|Rest]):-
	odd_parity(Rest).
	





	


